/*
 * Created on 15-Jan-2005
 */
package net.sourceforge.uml2svg;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Date;

/**
 * @author donald
 * @see @link http://www.javaworld.com/javaworld/jw-12-2000/jw-1229-traps.html
 */


/** What we do in this program is not overkill.
 *  It just circumvents some Java pitfalls.
 */
class StreamGobbler extends Thread {
    InputStream is;
    String type;
    
    StreamGobbler(InputStream is, String type) {
        this.is = is;
        this.type = type;
    }
    
    public void run() {
        try {
            InputStreamReader isr = new InputStreamReader(is);
            BufferedReader br = new BufferedReader(isr);
            String line=null;
            while ( (line = br.readLine()) != null) {
//                System.out.println(line);
//                System.out.println(type + ">" + line);
            }
        } catch (IOException ioe) {
            ioe.printStackTrace();  
        }
        System.out.flush();
    }
}

public class Stopwatch {

    public static void main(String[] args) throws IOException, InterruptedException {
        if (args.length>0) {
	        long start = (new Date()).getTime();
	        Process proc = Runtime.getRuntime().exec(args);
            StreamGobbler errorGobbler = new StreamGobbler(proc.getErrorStream(), "ERROR");            
            StreamGobbler outputGobbler = new StreamGobbler(proc.getInputStream(), "OUTPUT");
            errorGobbler.start();
            outputGobbler.start();
            int exitVal = proc.waitFor();
            System.out.println("Process exitValue: " + exitVal);
	        long stop = (new Date()).getTime();
	        System.out.println("Time:"+(stop-start));
        } else {
            System.err.println("Parameter command expected.");
        }
    }
}
